## git-annex 5.20150409+git21-g0ee0795-1~ndall+1

=== Makefile ===
mans=$(shell find doc -maxdepth 1 -name git-annex*.mdwn | sed -e 's/^doc/man/' -e 's/\.mdwn/\.1/')
all=git-annex mans docs

CABAL?=cabal # set to "./Setup" if you lack a cabal program
GHC?=ghc

PREFIX?=/usr
SHAREDIR?=share

# Am I typing :make in vim? Do a fast build.
ifdef VIM
all=fast
endif

build: build-stamp
build-stamp: $(all)
	touch $@

Build/SysConfig.hs: configure.hs Build/TestConfig.hs Build/Configure.hs
	if [ "$(CABAL)" = ./Setup ]; then ghc --make Setup; fi
	$(CABAL) configure

git-annex: Build/SysConfig.hs
	$(CABAL) build
	ln -sf dist/build/git-annex/git-annex git-annex

man/%.1: doc/%.mdwn
	./Build/mdwn2man $@ 1 $< > $@

# These are not built normally.
git-union-merge.1: doc/git-union-merge.mdwn
	./Build/mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1
git-union-merge:
	$(GHC) --make -threaded $@

install-mans: mans
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1
	install -m 0644 $(mans) $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1

install-docs: docs install-mans
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex
	if [ -d html ]; then \
		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex/html/; \
	fi

install: build install-docs Build/InstallDesktopFile
	install -d $(DESTDIR)$(PREFIX)/bin
	install git-annex $(DESTDIR)$(PREFIX)/bin
	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true

test: git-annex
	./git-annex test

retest: git-annex
	./git-annex test --rerun-update --rerun-filter failures

# hothasktags chokes on some template haskell etc, so ignore errors
tags:
	(for f in $$(find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$'); do hothasktags -c --cpp -c -traditional -c --include=dist/build/autogen/cabal_macros.h $$f; done) 2>/dev/null | sort > tags

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
ifeq ($(shell which ikiwiki),)
IKIWIKI=@echo "** ikiwiki not found, skipping building docs" >&2; true
else
IKIWIKI=ikiwiki
endif

mans: man $(mans)

man:
	mkdir -p man

docs: mans
	$(IKIWIKI) doc html -v --wikiname git-annex --plugin=goodstuff \
		--no-usedirs --disable-plugin=openid --plugin=sidebar \
		--underlaydir=/dev/null --disable-plugin=shortcut \
		--disable-plugin=smiley \
		--plugin=comments --set comments_pagespec="*" \
		--exclude='news/.*' --exclude='design/assistant/blog/*' \
		--exclude='bugs/*' --exclude='todo/*' --exclude='forum/*' \
		--exclude='users/*' --exclude='devblog/*'

clean:
	rm -rf tmp dist git-annex $(mans) configure  *.tix .hpc \
		doc/.ikiwiki html dist tags Build/SysConfig.hs build-stamp \
		Setup Build/InstallDesktopFile Build/EvilSplicer \
		Build/Standalone Build/OSXMkLibs Build/LinuxMkLibs \
		Build/DistributionUpdate Build/BuildVersion \
		git-union-merge .tasty-rerun-log
	find . -name \*.o -exec rm {} \;
	find . -name \*.hi -exec rm {} \;

Build/InstallDesktopFile: Build/InstallDesktopFile.hs
	$(GHC) --make $@ -Wall
Build/EvilSplicer: Build/EvilSplicer.hs
	$(GHC) --make $@ -Wall
Build/Standalone: Build/Standalone.hs Build/SysConfig.hs
	$(GHC) --make $@ -Wall
Build/OSXMkLibs: Build/OSXMkLibs.hs
	$(GHC) --make $@ -Wall
Build/LinuxMkLibs: Build/LinuxMkLibs.hs
	$(GHC) --make $@ -Wall

sdist: clean mans
	./Build/make-sdist.sh

# Upload to hackage.
hackage: sdist
	@cabal upload dist/*.tar.gz

LINUXSTANDALONE_DEST=tmp/git-annex.linux
linuxstandalone:
	$(MAKE) git-annex linuxstandalone-nobuild
linuxstandalone-nobuild: Build/Standalone Build/LinuxMkLibs
	rm -rf "$(LINUXSTANDALONE_DEST)"
	mkdir -p tmp
	cp -R standalone/linux/skel "$(LINUXSTANDALONE_DEST)"
	
	install -d "$(LINUXSTANDALONE_DEST)/bin"
	cp dist/build/git-annex/git-annex "$(LINUXSTANDALONE_DEST)/bin/"
	strip "$(LINUXSTANDALONE_DEST)/bin/git-annex"
	ln -sf git-annex "$(LINUXSTANDALONE_DEST)/bin/git-annex-shell"
	zcat standalone/licences.gz > $(LINUXSTANDALONE_DEST)/LICENSE
	cp doc/logo_16x16.png doc/logo.svg $(LINUXSTANDALONE_DEST)
	cp standalone/trustedkeys.gpg $(LINUXSTANDALONE_DEST)

	./Build/Standalone "$(LINUXSTANDALONE_DEST)"
	
	install -d "$(LINUXSTANDALONE_DEST)/git-core"
	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/git-core && tar x)
	install -d "$(LINUXSTANDALONE_DEST)/templates"
	
	./Build/LinuxMkLibs "$(LINUXSTANDALONE_DEST)"
	
	$(MAKE) install-mans DESTDIR="$(LINUXSTANDALONE_DEST)"

	cd tmp/git-annex.linux && find . -type f > git-annex.MANIFEST
	cd tmp/git-annex.linux && find . -type l >> git-annex.MANIFEST
	cd tmp && tar czf git-annex-standalone-$(shell dpkg --print-architecture).tar.gz git-annex.linux

OSXAPP_DEST=tmp/build-dmg/git-annex.app
OSXAPP_BASE=$(OSXAPP_DEST)/Contents/MacOS/bundle
osxapp: Build/Standalone Build/OSXMkLibs
	$(MAKE) git-annex

	rm -rf "$(OSXAPP_DEST)" "$(OSXAPP_BASE)"
	install -d tmp/build-dmg
	cp -R standalone/osx/git-annex.app "$(OSXAPP_DEST)"

	install -d "$(OSXAPP_BASE)"
	cp git-annex "$(OSXAPP_BASE)"
	strip "$(OSXAPP_BASE)/git-annex"
	ln -sf git-annex "$(OSXAPP_BASE)/git-annex-shell"
	gzcat standalone/licences.gz > $(OSXAPP_BASE)/LICENSE
	cp $(OSXAPP_BASE)/LICENSE tmp/build-dmg/LICENSE.txt
	cp standalone/trustedkeys.gpg $(OSXAPP_BASE)

	./Build/Standalone $(OSXAPP_BASE)

	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(OSXAPP_BASE)" && tar x)
	install -d "$(OSXAPP_BASE)/templates"

	# OSX looks in man dir nearby the bin
	$(MAKE) install-mans DESTDIR="$(OSXAPP_BASE)/.." SHAREDIR="" PREFIX=""

	./Build/OSXMkLibs $(OSXAPP_BASE)
	cd $(OSXAPP_DEST) && find . -type f > Contents/MacOS/git-annex.MANIFEST
	cd $(OSXAPP_DEST) && find . -type l >> Contents/MacOS/git-annex.MANIFEST
	rm -f tmp/git-annex.dmg
	hdiutil create -format UDBZ -size 640m -srcfolder tmp/build-dmg \
		-volname git-annex -o tmp/git-annex.dmg

# Must be run on a system with TH supported, and the same
# versions of TH splice generating packages as the arm system installed.
no-th-webapp-stage1: Build/EvilSplicer
	echo "Running throwaway build, to get TH splices.."
	if [ ! -e dist/setup/setup ]; then $(CABAL) configure -f-Production -O0;  fi
	mkdir -p tmp
	if ! $(CABAL) build --ghc-options=-ddump-splices 2> tmp/dump-splices; then tail tmp/dump-splices >&2; exit 1; fi
	echo "Setting up no-th build tree.."
	./Build/EvilSplicer tmp/splices tmp/dump-splices standalone/no-th/evilsplicer-headers.hs
	rsync -az --exclude tmp --exclude dist . tmp/no-th-tree
# Copy the files with expanded splices to the source tree, but
# only if the existing source file is not newer. (So, if a file
# used to have TH splices but they were removed, it will be newer,
# and not overwritten.)
	cp -uR tmp/splices/* tmp/no-th-tree || true
# Some additional dependencies needed by the expanded splices.
	sed -i 's/^  Build-Depends: /  Build-Depends: yesod-routes, yesod-core, shakespeare-css, shakespeare-js, shakespeare, blaze-markup, file-embed, wai-app-static, unordered-containers, /' tmp/no-th-tree/git-annex.cabal
# Avoid warnings due to sometimes unused imports added for the splices.
	sed -i 's/GHC-Options: \(.*\)-Wall/GHC-Options: \1-Wall -fno-warn-unused-imports /i' tmp/no-th-tree/git-annex.cabal
	sed -i 's/Extensions: /Extensions: MagicHash /i' tmp/no-th-tree/git-annex.cabal

# Run on the arm system, after stage1
no-th-webapp-stage2: 
	if [ ! -e tmp/no-th-tree/dist/setup-config ]; then \
		cd tmp/no-th-tree && cabal configure; \
	fi
	cd tmp/no-th-tree && cabal build --ghc-option=-D__NO_TH__
	cd tmp/no-th-tree && $(MAKE) linuxstandalone-nobuild

ANDROID_FLAGS?=
# Cross compile for Android.
# Uses https://github.com/neurocyte/ghc-android
android: Build/EvilSplicer
	echo "Running native build, to get TH splices.."
	if [ ! -e dist/setup/setup ]; then $(CABAL) configure -f-Production -O0 $(ANDROID_FLAGS) -fAndroidSplice;  fi
	mkdir -p tmp
	if ! $(CABAL) build --ghc-options=-ddump-splices 2> tmp/dump-splices; then tail tmp/dump-splices >&2; exit 1; fi
	echo "Setting up Android build tree.."
	./Build/EvilSplicer tmp/splices tmp/dump-splices standalone/no-th/evilsplicer-headers.hs
	rsync -az --exclude tmp --exclude dist . tmp/androidtree
# Copy the files with expanded splices to the source tree, but
# only if the existing source file is not newer. (So, if a file
# used to have TH splices but they were removed, it will be newer,
# and not overwritten.)
	cp -uR tmp/splices/* tmp/androidtree || true
# Some additional dependencies needed by the expanded splices.
	sed -i 's/^  Build-Depends: /  Build-Depends: yesod-routes, yesod-core, shakespeare-css, shakespeare-js, shakespeare, blaze-markup, file-embed, wai-app-static, unordered-containers, /' tmp/androidtree/git-annex.cabal
# Avoid warnings due to sometimes unused imports added for the splices.
	sed -i 's/GHC-Options: \(.*\)-Wall/GHC-Options: \1-Wall -fno-warn-unused-imports /i' tmp/androidtree/git-annex.cabal
	sed -i 's/Extensions: /Extensions: MagicHash /i' tmp/androidtree/git-annex.cabal
# Cabal cannot cross compile with custom build type, so workaround.
	sed -i 's/Build-type: Custom/Build-type: Simple/' tmp/androidtree/git-annex.cabal
# Build just once, but link repeatedly, for different versions of Android.
	mkdir -p tmp/androidtree/dist/build/git-annex/4.0 tmp/androidtree/dist/build/git-annex/4.3 tmp/androidtree/dist/build/git-annex/5.0
	if [ ! -e tmp/androidtree/dist/setup-config ]; then \
		cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal configure -fAndroid $(ANDROID_FLAGS); \
	fi
	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
		&& mv dist/build/git-annex/git-annex dist/build/git-annex/4.0/git-annex
	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
		--ghc-options=-optl-z --ghc-options=-optlnocopyreloc \
		&& mv dist/build/git-annex/git-annex dist/build/git-annex/4.3/git-annex
	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
		--ghc-options=-optl-z --ghc-options=-optlnocopyreloc --ghc-options=-optl-fPIE --ghc-options=-optl-pie --ghc-options=-optc-fPIE --ghc-options=-optc-pie \
		&& mv dist/build/git-annex/git-annex dist/build/git-annex/5.0/git-annex

androidapp:
	$(MAKE) android
	$(MAKE) -C standalone/android

# We bypass cabal, and only run the main ghc --make command for a
# fast development built. Note: Does not rebuild C libraries.
fast: dist/caballog
	@$$(grep 'ghc --make' dist/caballog | head -n 1 | sed -e 's/-package-id [^ ]*//g' -e 's/-hide-all-packages//') -O0
	@ln -sf dist/build/git-annex/git-annex git-annex
	@$(MAKE) tags >/dev/null 2>&1 &

dist/caballog: git-annex.cabal
	$(CABAL) configure -f"-Production" -O0
	$(CABAL) build -v2 | tee $@

# Hardcoded command line to make hdevtools start up and work.
# You will need some memory. It's worth it.
# Note: Don't include WebDAV or Webapp. TH use bloats memory > 500 mb!
# TODO should be possible to derive this from caballog.
hdevtools:
	hdevtools --stop-server || true
	hdevtools check git-annex.hs -g -cpp -g -i -g -idist/build/git-annex/git-annex-tmp -g -i. -g -idist/build/autogen -g -Idist/build/autogen -g -Idist/build/git-annex/git-annex-tmp -g -IUtility -g -DWITH_TESTSUITE -g -DWITH_S3 -g -DWITH_ASSISTANT -g -DWITH_INOTIFY -g -DWITH_DBUS -g -DWITH_PAIRING -g -DWITH_XMPP -g -optP-include -g -optPdist/build/autogen/cabal_macros.h -g -odir -g dist/build/git-annex/git-annex-tmp -g -hidir -g dist/build/git-annex/git-annex-tmp -g -stubdir -g dist/build/git-annex/git-annex-tmp -g -threaded -g -Wall -g -XHaskell98 -g -XPackageImports

distributionupdate:
	git pull
	cabal configure
	ghc -Wall --make Build/DistributionUpdate -XPackageImports -optP-include -optPdist/build/autogen/cabal_macros.h
	./Build/DistributionUpdate

.PHONY: git-annex git-union-merge git-recover-repository tags build-stamp

=== debian/changelog ===
git-annex (5.20150409+git21-g0ee0795-1~ndall+1) neurodebian; urgency=medium

  * Backported fresh snapshot

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 12 Apr 2015 09:27:26 -0400

git-annex (5.20150410) UNRELEASED; urgency=medium

  * Fix activity log parsing, which caused the log to not retain
    activity from other uuids.
  * Union merge could fall over if there was a file in the repository
    with the same name as a git ref. Now fixed.

 -- Joey Hess <id@joeyh.name>  Thu, 09 Apr 2015 20:59:43 -0400

git-annex (5.20150409) unstable; urgency=medium

  * This fixes a bug in the assistant introduced by the literal pathspec
    changes in version 5.20150406.
  * --quiet now suppresses progress displays from eg, rsync.
    (Second time's the charm..)
  * fromkey, registerurl: When reading from stdin, allow the
    filename and url, respectively, to contain whitespace.
  * add: If annex.largefiles is set and does not match a file that's being
    added, the file will be checked into git rather than being added to the
    annex. Previously, git annex add skipped over such files; this new
    behavior is more useful in direct mode.
  * proxy: Made it work when run in a new repository before initial
    commit.
  * info: Display repository mode: bare when in a bare (non-direct mode)
    repo.
  * importfeed: Fix feed download when curl is used.
  * importfeed: Error out when passed a non-url.
  * webapp: When adding another local repository, and combining it
    with the current repository, the new repository's remote path
    was set to "." rather than the path to the current repository.
    This was a reversion caused by the relative path changes in 5.20150113.
  * contentlocationn: New plumbing command.

 -- Joey Hess <id@joeyh.name>  Thu, 09 Apr 2015 15:06:38 -0400

git-annex (5.20150406.1) unstable; urgency=medium

  * Fixes a bug in the last release that caused rsync and possibly
    other commands to hang at the end of a file transfer.
    (--quiet is back to not blocking progress displays until
    that code can be fixed properly.)

 -- Joey Hess <id@joeyh.name>  Mon, 06 Apr 2015 17:13:13 -0400

git-annex (5.20150406) unstable; urgency=medium

  * Prevent git-ls-files from double-expanding wildcards when an
    unexpanded wildcard is passed to a git-annex command like add or find.
  * Fix make build target. Thanks, Justin Geibel.
  * Fix GETURLS in external special remote protocol to strip
    downloader prefix from logged url info before checking for the
    specified prefix.
  * importfeed: Avoid downloading a redundant item from a feed whose
    guid has been downloaded before, even when the url has changed.
  * importfeed: Always store itemid in metadata; before this was only
    done when annex.genmetadata was set.
  * Relax debian package dependencies to git >= 1:1.8.1 rather
    than needing >= 1:2.0.
  * test: Fix --list-tests
  * addurl --file: When used with a special remote that claims
    urls and checks their contents, don't override the user's provided
    filename with filenames that the special remote suggests. Also,
    don't allow adding the url if the special remote says it contains
    multiple files.
  * import: --deduplicate and --cleanduplicates now output the keys
    corresponding to duplicated files they process.
  * expire: New command, for expiring inactive repositories.
  * fsck: Record fsck activity for use by expire command.
  * Fix truncation of parameters that could occur when using xargs git-annex.
  * Significantly sped up processing of large numbers of directories
    passed to a single git-annex command.
  * version: Add --raw
  * init: Improve fifo test to detect NFS systems that support fifos
    but not well enough for sshcaching.
  * --quiet now suppresses progress displays from eg, rsync.
    (The option already suppressed git-annex's own built-in progress
    displays.)

 -- Joey Hess <id@joeyh.name>  Mon, 06 Apr 2015 12:48:48 -0400

git-annex (5.20150327) unstable; urgency=medium

  * readpresentkey: New plumbing command for checking location log.
  * checkpresentkey: New plumbing command to check if a key can be verified
    to be present on a remote.
  * Added a post-update-annex hook, which is run after the git-annex branch
    is updated. Needed for git update-server-info.
  * migrate: --force will force migration of keys already using the
    destination backend. Useful in rare cases.
  * Man pages for individual commands now available, and can be
    opened using "git annex help <command>"
  * --auto is no longer a global option; only get, drop, and copy
    accept it. (Not a behavior change unless you were passing it to a
    command that ignored it.)
  * Improve error message when --in @date is used and there is no
    reflog for the git-annex branch.
  * assistant: Committing a whole lot of files at once could overflow
    command-line length limits and cause the commit to fail. This
    only happened when using the assistant in an indirect mode repository.
  * Work around curl bug when asked to download an empty url to a file.
  * Fix bug introduced in the last release that broke git-annex sync
    when git-annex was installed from the standalone tarball.

 -- Joey Hess <id@joeyh.name>  Fri, 27 Mar 2015 13:10:59 -0400

git-annex (5.20150317) unstable; urgency=medium

  * fsck: Incremental fsck uses sqlite to store its records, instead
    of abusing the sticky bit. Existing sticky bits are ignored;
    incremental fscks started by old versions won't be resumed by
    this version.
  * fsck: Multiple incremental fscks of different repos (including remotes)
    can now be running at the same time in the same repo without it
    getting confused about which files have been checked for which remotes.
  * unannex: Refuse to unannex when repo is too new to have a HEAD,
    since in this case there must be staged changes in the index
    (if there is anything to unannex), and the unannex code path


=== debian/control ===
Source: git-annex
Section: utils
Priority: optional
Build-Depends: 
	debhelper (>= 9),
	ghc (>= 7.4),
	cabal-install,
	libghc-mtl-dev (>= 2.1.1),
	libghc-missingh-dev,
	libghc-data-default-dev,
	libghc-hslogger-dev,
	libghc-pcre-light-dev,
	libghc-sha-dev,
	libghc-cryptohash-dev,
	libghc-dataenc-dev,
	libghc-utf8-string-dev,
	libghc-aws-dev (>= 0.9.2-2~),
	libghc-conduit-dev,
	libghc-resourcet-dev,
	libghc-dav-dev (>= 1.0) [amd64 i386 kfreebsd-amd64 kfreebsd-i386 powerpc],
	libghc-quickcheck2-dev,
	libghc-monad-control-dev (>= 0.3),
	libghc-exceptions-dev (>= 0.6),
	libghc-transformers-dev,
	libghc-unix-compat-dev,
	libghc-dlist-dev,
	libghc-uuid-dev,
	libghc-json-dev,
	libghc-aeson-dev,
	libghc-ifelse-dev,
	libghc-bloomfilter-dev,
	libghc-edit-distance-dev,
	libghc-hinotify-dev [linux-any],
	libghc-stm-dev (>= 2.3),
	libghc-dbus-dev (>= 0.10.3) [linux-any],
	libghc-fdo-notify-dev (>= 0.3) [linux-any],
	libghc-yesod-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-yesod-static-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-yesod-default-dev [i386 amd64 kfreebsd-amd64 powerpc],
	libghc-hamlet-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-shakespeare-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-clientsession-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-warp-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-warp-tls-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-wai-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-wai-extra-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-securemem-dev,
	libghc-byteable-dev,
	libghc-dns-dev,
	libghc-case-insensitive-dev,
	libghc-http-types-dev,
	libghc-http-conduit-dev,
	libghc-blaze-builder-dev,
	libghc-crypto-api-dev,
	libghc-network-multicast-dev,
	libghc-network-info-dev [linux-any kfreebsd-any],
	libghc-safesemaphore-dev,
	libghc-network-protocol-xmpp-dev (>= 0.4.3-1+b1),
	libghc-gnutls-dev (>= 0.1.4),
	libghc-xml-types-dev,
	libghc-async-dev,
	libghc-persistent-dev,
	libghc-persistent-template-dev,
	libghc-persistent-sqlite-dev,
	libghc-esqueleto-dev,
	libghc-monad-logger-dev,
	libghc-feed-dev (>= 0.3.9.2),
	libghc-regex-tdfa-dev [!mipsel !s390],
	libghc-regex-compat-dev [mipsel s390],
	libghc-tasty-dev (>= 0.7) [!sparc],
	libghc-tasty-hunit-dev [!sparc],
	libghc-tasty-quickcheck-dev [!sparc],
	libghc-tasty-rerun-dev [!sparc],
	libghc-optparse-applicative-dev [!sparc],
	lsof [!kfreebsd-i386 !kfreebsd-amd64 !hurd-any],
	ikiwiki,
	perlmagick,
	git (>= 1:1.8.1),
	rsync,
	wget,
	curl,
	openssh-client,
	git-remote-gcrypt (>= 0.20130908-6),
	llvm-3.4 [armel armhf],
Maintainer: Gergely Nagy <algernon@madhouse-project.org>
Standards-Version: 3.9.6
Vcs-Git: git://git.kitenet.net/git-annex
Homepage: http://git-annex.branchable.com/
XS-Testsuite: autopkgtest

Package: git-annex-standalone
Architecture: any
Section: utils
Conflicts: git-annex
Provides: git-annex
Depends: ${misc:Depends},
	rsync,
	wget,
	curl,
	openssh-client (>= 1:5.6p1)
Recommends: 
	lsof,
	gnupg,
	bind9-host,
	quvi,
	git-remote-gcrypt (>= 0.20130908-6),
	nocache,
	aria2,
	bittornado | bittorrent,
Suggests:
	git,
	graphviz,
	bup,
	tahoe-lafs,
	libnss-mdns,
Description: manage files with git, without checking their contents into git -- standalone build
 git-annex allows managing files with git, without checking the file
 contents into git. While that may seem paradoxical, it is useful when
 dealing with files larger than git can currently easily handle, whether due
 to limitations in memory, time, or disk space.
 .
 It can store large files in many places, from local hard drives, to a
 large number of cloud storage services, including S3, WebDAV,
 and rsync, with a dozen cloud storage providers usable via plugins.
 Files can be stored encrypted with gpg, so that the cloud storage
 provider cannot see your data. git-annex keeps track of where each file
 is stored, so it knows how many copies are available, and has many
 facilities to ensure your data is preserved.
 .
 git-annex can also be used to keep a folder in sync between computers,
 noticing when files are changed, and automatically committing them
 to git and transferring them to other computers. The git-annex webapp
 makes it easy to set up and use git-annex this way.
 .
 This package provides a standalone bundle build of git-annex, which
 should be installable on any more or less recent Debian or Ubuntu
 release.

=== debian/rules ===
#!/usr/bin/make -f

export CABAL=debian/cabal-wrapper

# Do use the changelog's version number, rather than making one up.
export RELEASE_BUILD=0

%:
	dh $@

override_dh_auto_build:
	make linuxstandalone

override_dh_auto_install:
	: # nothing to do, we just need to copy the beast, as instructed in debian/install

override_dh_fixperms:
	dh_fixperms -Xld-linux

## git-annex 5.20150710

=== Makefile ===
--- 
+++ 
@@ -62,7 +62,7 @@
 # If ikiwiki is available, build static html docs suitable for being
 # shipped in the software package.
 ifeq ($(shell which ikiwiki),)
-IKIWIKI=@echo "** ikiwiki not found, skipping building docs" >&2; true
+IKIWIKI=echo "** ikiwiki not found, skipping building docs" >&2; true
 else
 IKIWIKI=ikiwiki
 endif
@@ -73,10 +73,11 @@
 	mkdir -p man
 
 docs: mans
-	$(IKIWIKI) doc html -v --wikiname git-annex --plugin=goodstuff \
+	LC_ALL=C TZ=UTC $(IKIWIKI) doc html -v --wikiname git-annex \
+		--plugin=goodstuff \
 		--no-usedirs --disable-plugin=openid --plugin=sidebar \
-		--underlaydir=/dev/null --disable-plugin=shortcut \
-		--disable-plugin=smiley \
+		--underlaydir=/dev/null --set deterministic=1 \
+		--disable-plugin=shortcut --disable-plugin=smiley \
 		--plugin=comments --set comments_pagespec="*" \
 		--exclude='news/.*' --exclude='design/assistant/blog/*' \
 		--exclude='bugs/*' --exclude='todo/*' --exclude='forum/*' \
@@ -93,15 +94,15 @@
 	find . -name \*.hi -exec rm {} \;
 
 Build/InstallDesktopFile: Build/InstallDesktopFile.hs
-	$(GHC) --make $@ -Wall
+	$(GHC) --make $@ -Wall -fno-warn-tabs
 Build/EvilSplicer: Build/EvilSplicer.hs
-	$(GHC) --make $@ -Wall
+	$(GHC) --make $@ -Wall -fno-warn-tabs
 Build/Standalone: Build/Standalone.hs Build/SysConfig.hs
-	$(GHC) --make $@ -Wall
+	$(GHC) --make $@ -Wall -fno-warn-tabs
 Build/OSXMkLibs: Build/OSXMkLibs.hs
-	$(GHC) --make $@ -Wall
+	$(GHC) --make $@ -Wall -fno-warn-tabs
 Build/LinuxMkLibs: Build/LinuxMkLibs.hs
-	$(GHC) --make $@ -Wall
+	$(GHC) --make $@ -Wall -fno-warn-tabs
 
 sdist: clean mans
 	./Build/make-sdist.sh
@@ -138,7 +139,29 @@
 
 	cd tmp/git-annex.linux && find . -type f > git-annex.MANIFEST
 	cd tmp/git-annex.linux && find . -type l >> git-annex.MANIFEST
-	cd tmp && tar czf git-annex-standalone-$(shell dpkg --print-architecture).tar.gz git-annex.linux
+	cd tmp && tar c git-annex.linux | gzip -9 --rsyncable > git-annex-standalone-$(shell dpkg --print-architecture).tar.gz
+
+# Run this target to build git-annex-standalone*.deb
+debianstandalone: dpkg-buildpackage-F
+# Run this target to build git-annex-standalone*.dsc
+debianstandalone-dsc: dpkg-buildpackage-S
+
+prep-standalone:
+	$(MAKE) undo-standalone
+	QUILT_PATCHES=debian/patches QUILT_SERIES=series.standalone-build quilt push -a
+	debian/create-standalone-changelog
+
+undo-standalone:
+	test -e .git
+	git checkout debian/changelog
+	quilt pop -a || true
+
+commit-standalone:
+	QUILT_PATCHES=debian/patches QUILT_SERIES=series.standalone-build  quilt refresh
+
+dpkg-buildpackage%: prep-standalone
+	umask 022; dpkg-buildpackage -rfakeroot $*
+	$(MAKE) undo-standalone
 
 OSXAPP_DEST=tmp/build-dmg/git-annex.app
 OSXAPP_BASE=$(OSXAPP_DEST)/Contents/MacOS/bundle
@@ -155,7 +178,7 @@
 	ln -sf git-annex "$(OSXAPP_BASE)/git-annex-shell"
 	gzcat standalone/licences.gz > $(OSXAPP_BASE)/LICENSE
 	cp $(OSXAPP_BASE)/LICENSE tmp/build-dmg/LICENSE.txt
-	cp standalone/trustedkeys.gpg $(OSXAPP_BASE)
+	cp standalone/trustedkeys.gpg $(OSXAPP_DEST)/Contents/MacOS
 
 	./Build/Standalone $(OSXAPP_BASE)
 
@@ -171,35 +194,6 @@
 	rm -f tmp/git-annex.dmg
 	hdiutil create -format UDBZ -size 640m -srcfolder tmp/build-dmg \
 		-volname git-annex -o tmp/git-annex.dmg
-
-# Must be run on a system with TH supported, and the same
-# versions of TH splice generating packages as the arm system installed.
-no-th-webapp-stage1: Build/EvilSplicer
-	echo "Running throwaway build, to get TH splices.."
-	if [ ! -e dist/setup/setup ]; then $(CABAL) configure -f-Production -O0;  fi
-	mkdir -p tmp
-	if ! $(CABAL) build --ghc-options=-ddump-splices 2> tmp/dump-splices; then tail tmp/dump-splices >&2; exit 1; fi
-	echo "Setting up no-th build tree.."
-	./Build/EvilSplicer tmp/splices tmp/dump-splices standalone/no-th/evilsplicer-headers.hs
-	rsync -az --exclude tmp --exclude dist . tmp/no-th-tree
-# Copy the files with expanded splices to the source tree, but
-# only if the existing source file is not newer. (So, if a file
-# used to have TH splices but they were removed, it will be newer,
-# and not overwritten.)
-	cp -uR tmp/splices/* tmp/no-th-tree || true
-# Some additional dependencies needed by the expanded splices.
-	sed -i 's/^  Build-Depends: /  Build-Depends: yesod-routes, yesod-core, shakespeare-css, shakespeare-js, shakespeare, blaze-markup, file-embed, wai-app-static, unordered-containers, /' tmp/no-th-tree/git-annex.cabal
-# Avoid warnings due to sometimes unused imports added for the splices.
-	sed -i 's/GHC-Options: \(.*\)-Wall/GHC-Options: \1-Wall -fno-warn-unused-imports /i' tmp/no-th-tree/git-annex.cabal
-	sed -i 's/Extensions: /Extensions: MagicHash /i' tmp/no-th-tree/git-annex.cabal
-
-# Run on the arm system, after stage1
-no-th-webapp-stage2: 
-	if [ ! -e tmp/no-th-tree/dist/setup-config ]; then \
-		cd tmp/no-th-tree && cabal configure; \
-	fi
-	cd tmp/no-th-tree && cabal build --ghc-option=-D__NO_TH__
-	cd tmp/no-th-tree && $(MAKE) linuxstandalone-nobuild
 
 ANDROID_FLAGS?=
 # Cross compile for Android.
@@ -218,7 +212,7 @@
 # and not overwritten.)
 	cp -uR tmp/splices/* tmp/androidtree || true
 # Some additional dependencies needed by the expanded splices.
-	sed -i 's/^  Build-Depends: /  Build-Depends: yesod-routes, yesod-core, shakespeare-css, shakespeare-js, shakespeare, blaze-markup, file-embed, wai-app-static, unordered-containers, /' tmp/androidtree/git-annex.cabal
+	sed -i 's/^  Build-Depends: */  Build-Depends: yesod-core, shakespeare, blaze-markup, file-embed, wai-app-static, wai, unordered-containers, /' tmp/androidtree/git-annex.cabal
 # Avoid warnings due to sometimes unused imports added for the splices.
 	sed -i 's/GHC-Options: \(.*\)-Wall/GHC-Options: \1-Wall -fno-warn-unused-imports /i' tmp/androidtree/git-annex.cabal
 	sed -i 's/Extensions: /Extensions: MagicHash /i' tmp/androidtree/git-annex.cabal
@@ -243,14 +237,15 @@
 	$(MAKE) -C standalone/android
 
 # We bypass cabal, and only run the main ghc --make command for a
-# fast development built. Note: Does not rebuild C libraries.
+# fast development built. Note: Does not rebuild C libraries, or link
+# executable.
 fast: dist/caballog
 	@$$(grep 'ghc --make' dist/caballog | head -n 1 | sed -e 's/-package-id [^ ]*//g' -e 's/-hide-all-packages//') -O0
 	@ln -sf dist/build/git-annex/git-annex git-annex
 	@$(MAKE) tags >/dev/null 2>&1 &
 
 dist/caballog: git-annex.cabal
-	$(CABAL) configure -f"-Production" -O0
+	$(CABAL) configure -f"-Production" -O0 --enable-executable-dynamic
 	$(CABAL) build -v2 | tee $@
 
 # Hardcoded command line to make hdevtools start up and work.

=== debian/changelog ===
git-annex (5.20150710-2) unstable; urgency=medium

  [ Richard Hartmann ]
  * Joey Hess had fixed 786659. Closes #786659

 -- Richard Hartmann <richih@debian.org>  Thu, 23 Jul 2015 01:05:44 +0200

git-annex (5.20150710-1) unstable; urgency=medium

  [ Joey Hess ]
  * add: Stage symlinks the same as git add would, even if they are not a
    link to annexed content.
  * sync: When annex.autocommit=false, avoid making any commit of local
    changes, while still merging with remote to the extent possible.
  * unused: --used-refspec can now be configured to look at refs in the
    reflog. This provides a way to not consider old versions of files to be
    unused after they have reached a specified age, when the old refs in
    the reflog expire.
  * log: Fix reversion introduced in version 5.20150528 that broke this command.
  * assistant --autostart: First stop any daemons that are already running,
    which might be left over from a previous login session and so unable to
    use the ssh agent of a new login session.
  * assistant: Fix local pairing to not include newline in ssh pubkey,
    which is rejected on the other end for security reasons.
  * assistant: Fix ANNEX_SHELL_DIR written to ~/.ssh/authorized_keys 
    in local pairing to be the absolute path to the repository, not "."
    This was a reversion caused by the relative path changes in 5.20150113.
  * Brought back the setkey plumbing command that was removed in 2011, since
    we found a use case for it. Note that the command's syntax was changed
    for consistency.
  * bugfix: Pass --full-tree when using git ls-files to get a list of files
    on the git-annex branch, so it works when run in a subdirectory.
    This bug affected git-annex unused, and potentially also transitions
    running code and other things.
  * Support git's undocumented core.sharedRepository=2 value, which
    is equivalent to "world", and is set when a repo was created using
    git init --shared=world.
  * When building on linux, pass --as-needed to linker to avoid linking
    with unused shared libraries including libyaml.
  * import: Fix failure of cross-device import on Windows.
  * merge: Avoid creating the synced/master branch.
  * Removed support for optparse-applicative versions older than 0.10.

  [ Richard Hartmann ]
  * Switch to dpkg-source 3.0 (quilt) format, just so we have any non-native
    format
  * Switched Maintainer to Richard Hartmann

 -- Richard Hartmann <richih@debian.org>  Wed, 22 Jul 2015 23:49:46 +0200

git-annex (5.20150617) unstable; urgency=medium

  * Now supports git annex sync --all --content to sync all versions of all
    files with all repos that want them.
  * Added new "anything" preferred content expression, which matches all
    versions of all files.
  * Standard preferred content for client, backup, incremental backup,
    and unwanted groups have been adjusted to work better when used
    with git annex sync --all --content.
  * fromkey, registerurl: Improve handling of urls that happen to also
    be parsable as strange keys.
  * sync, remotedaemon: Pass configured ssh-options even when
    annex.sshcaching is disabled.
  * assistant: Consume systemd-networkd dbus events to learn about
    changes to network connections, as was already done with
    network-manager and wicd.
    Thanks to Sebastian Reuße for the patches.
  * get --incomplete: New option to resume any interrupted downloads.
  * dead --key: Can be used to mark a key as dead.
  * fsck: Ignore keys that are known to be dead when running in
    --all/--unused/--key mode or a in a bare repo. Closes: #753888
    Otherwise, still reports files with lost contents, even if the content
    is dead.
  * S3: Special remotes can be configured with public=yes to allow
    the public to access the bucket's content.
  * S3: Publically accessible buckets can be used without creds.
  * import --clean-duplicates: Fix bug that didn't count local or trusted
    repo's copy of a file as one of the necessary copies to allow removing
    it from the import location.
  * tahoe: Use ~/.tahoe-git-annex/ rather than ~/.tahoe/git-annex/
    when setting up a tahoe special remote to avoid old versions of
    tahoe create-client choking.
  * Fix bug that prevented enumerating locally present objects in repos
    tuned with annex.tune.objecthash1=true.
    Fixes: unused, object count in info, unannex.
  * Improve url parsing to handle some urls containing illegal []
    characters in their paths.
  * info: Added json output for "backend usage", "numcopies stats",
    "repositories containing these files", and "transfers in progress".
  * Fix incremental backup standard preferred content expression to match
    its documentation, which says it does not want files that have reached
    a backup repository.
  * Increased the default annex.bloomaccuracy from 1000 to 10000000.
    This makes git annex unused use up to 16 mb more memory than it did
    before, but the massive increase in accuracy makes this worthwhile
    for all but the smallest systems.
  * Build documentation with deterministic=1 for reproducible builds.
    (A new ikiwiki feature.) Closes: #785736
  * Re-remove dependency on obsolete hamlet package. Closes: #786659
  * debian/cabal-wrapper: Removed this hack which should not be needed anymore.

 -- Joey Hess <id@joeyh.name>  Wed, 17 Jun 2015 13:50:35 -0400

git-annex (5.20150528) unstable; urgency=medium

  * fromkey, registerurl: Allow urls to be specified instead of keys,
    and generate URL keys.
  * Linux standalone, OSX app: Improve runshell script to always quote
    shell vars, so that it will work when eg, untarred into a directory
    path with spaces in its name.
  * Revert removal dependency on obsolete hamlet package, since the
    autobuilders are not ready for this change yet and it prevented them
    from building the webapp. Reopens: #786659
  * fsck: When checksumming a file fails due to a hardware fault,


=== debian/control ===
Source: git-annex
Section: utils
Priority: optional
Build-Depends: 
	debhelper (>= 9),
	ghc (>= 7.4),
	libghc-mtl-dev (>= 2.1.1),
	libghc-missingh-dev,
	libghc-data-default-dev,
	libghc-hslogger-dev,
	libghc-pcre-light-dev,
	libghc-cryptohash-dev (>= 0.11.0),
	libghc-sandi-dev,
	libghc-utf8-string-dev,
	libghc-aws-dev (>= 0.9.2-2~),
	libghc-conduit-dev,
	libghc-resourcet-dev,
	libghc-dav-dev (>= 1.0) [amd64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 powerpc ppc64el hurd-i386],
	libghc-quickcheck2-dev,
	libghc-monad-control-dev (>= 0.3),
	libghc-exceptions-dev (>= 0.6),
	libghc-transformers-dev,
	libghc-unix-compat-dev,
	libghc-dlist-dev,
	libghc-uuid-dev,
	libghc-json-dev,
	libghc-aeson-dev,
	libghc-ifelse-dev,
	libghc-bloomfilter-dev,
	libghc-edit-distance-dev,
	libghc-hinotify-dev [linux-any],
	libghc-stm-dev (>= 2.3),
	libghc-dbus-dev (>= 0.10.7) [linux-any],
	libghc-fdo-notify-dev (>= 0.3) [linux-any],
	libghc-yesod-dev (>= 1.2.6.1) [i386 amd64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el],
	libghc-yesod-core-dev (>= 1.2.19) [i386 amd64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el],
	libghc-yesod-form-dev (>= 1.3.15) [i386 amd64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el],
	libghc-yesod-static-dev (>= 1.2.4) [i386 amd64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el],
	libghc-yesod-default-dev (>= 1.2.0) [i386 amd64 armel armhf kfreebsd-amd64 powerpc ppc64el],
	libghc-shakespeare-dev (>= 2.0.0) [i386 amd64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el],
	libghc-clientsession-dev [i386 amd64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el],
	libghc-warp-dev (>= 3.0.0.5) [i386 amd64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el],
	libghc-warp-tls-dev [i386 amd64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el],
	libghc-wai-dev [i386 amd64 kfreebsd-i386 armel armhf kfreebsd-amd64 powerpc ppc64el],
	libghc-wai-extra-dev [i386 amd64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el],
	libghc-securemem-dev,
	libghc-byteable-dev,
	libghc-dns-dev,
	libghc-case-insensitive-dev,
	libghc-http-types-dev,
	libghc-http-conduit-dev,
	libghc-blaze-builder-dev,
	libghc-crypto-api-dev,
	libghc-network-multicast-dev,
	libghc-network-info-dev [linux-any kfreebsd-any],
	libghc-safesemaphore-dev,
	libghc-network-protocol-xmpp-dev (>= 0.4.3-1+b1),
	libghc-gnutls-dev (>= 0.1.4),
	libghc-xml-types-dev,
	libghc-async-dev,
	libghc-persistent-dev,
	libghc-persistent-template-dev,
	libghc-persistent-sqlite-dev,
	libghc-esqueleto-dev,
	libghc-monad-logger-dev,
	libghc-feed-dev (>= 0.3.9.2),
	libghc-regex-tdfa-dev,
	libghc-tasty-dev (>= 0.7),
	libghc-tasty-hunit-dev,
	libghc-tasty-quickcheck-dev,
	libghc-tasty-rerun-dev,
	libghc-optparse-applicative-dev (>= 0.10),
	lsof [!kfreebsd-i386 !kfreebsd-amd64 !hurd-any],
	ikiwiki,
	perlmagick,
	git (>= 1:1.8.1),
	rsync,
	wget,
	curl,
	openssh-client,
	git-remote-gcrypt (>= 0.20130908-6),
Maintainer: Richard Hartmann <richih@debian.org>
Standards-Version: 3.9.6
Vcs-Git: git://git.kitenet.net/git-annex
Homepage: http://git-annex.branchable.com/
XS-Testsuite: autopkgtest

Package: git-annex
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends},
	git (>= 1:1.8.1),
	rsync,
	wget,
	curl,
	openssh-client (>= 1:5.6p1)
Recommends: 
	lsof,
	gnupg,
	bind9-host,
	quvi,
	git-remote-gcrypt (>= 0.20130908-6),
	nocache,
	aria2,
	bittornado | bittorrent,
Suggests:
	graphviz,
	bup,
	tahoe-lafs,
	libnss-mdns,
Description: manage files with git, without checking their contents into git
 git-annex allows managing files with git, without checking the file
 contents into git. While that may seem paradoxical, it is useful when
 dealing with files larger than git can currently easily handle, whether due
 to limitations in memory, time, or disk space.
 .
 It can store large files in many places, from local hard drives, to a
 large number of cloud storage services, including S3, WebDAV,
 and rsync, with a dozen cloud storage providers usable via plugins.
 Files can be stored encrypted with gpg, so that the cloud storage
 provider cannot see your data. git-annex keeps track of where each file
 is stored, so it knows how many copies are available, and has many
 facilities to ensure your data is preserved.
 .
 git-annex can also be used to keep a folder in sync between computers,
 noticing when files are changed, and automatically committing them
 to git and transferring them to other computers. The git-annex webapp
 makes it easy to set up and use git-annex this way.

## git-annex 5.20150727

=== Makefile ===
--- 
+++ 
@@ -12,9 +12,7 @@
 all=fast
 endif
 
-build: build-stamp
-build-stamp: $(all)
-	touch $@
+build: $(all)
 
 Build/SysConfig.hs: configure.hs Build/TestConfig.hs Build/Configure.hs
 	if [ "$(CABAL)" = ./Setup ]; then ghc --make Setup; fi
@@ -48,6 +46,8 @@
 	install git-annex $(DESTDIR)$(PREFIX)/bin
 	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
 	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true
+	install -d $(DESTDIR)$(PREFIX)/share/bash-completion/completions
+	install -m 0644 bash-completion.bash $(DESTDIR)$(PREFIX)/share/bash-completion/completions/git-annex
 
 test: git-annex
 	./git-annex test
@@ -85,7 +85,7 @@
 
 clean:
 	rm -rf tmp dist git-annex $(mans) configure  *.tix .hpc \
-		doc/.ikiwiki html dist tags Build/SysConfig.hs build-stamp \
+		doc/.ikiwiki html dist tags Build/SysConfig.hs \
 		Setup Build/InstallDesktopFile Build/EvilSplicer \
 		Build/Standalone Build/OSXMkLibs Build/LinuxMkLibs \
 		Build/DistributionUpdate Build/BuildVersion \
@@ -262,4 +262,4 @@
 	ghc -Wall --make Build/DistributionUpdate -XPackageImports -optP-include -optPdist/build/autogen/cabal_macros.h
 	./Build/DistributionUpdate
 
-.PHONY: git-annex git-union-merge git-recover-repository tags build-stamp
+.PHONY: git-annex git-union-merge tags

=== debian/changelog ===
git-annex (5.20150727-2) unstable; urgency=medium

  * Remove lintian from gbp.conf for now.

 -- Richard Hartmann <richih@debian.org>  Wed, 29 Jul 2015 21:05:31 +0200

git-annex (5.20150727-1) unstable; urgency=medium

  * Package 5.20150727

 -- Richard Hartmann <richih@debian.org>  Wed, 29 Jul 2015 00:44:11 +0200

git-annex (5.20150727) unstable; urgency=medium

  * Fix bug that prevented uploads to remotes using new-style chunking
    from resuming after the last successfully uploaded chunk.
  * Switched option parsing to use optparse-applicative. This was a very large
    and invasive change, and may have caused some minor behavior changes to
    edge cases of option parsing. (For example, the metadata command no
    longer accepts the combination of --get and --set, which never actually
    worked.)
  * Bash completion file is now included in the git-annex source tree, 
    and installed into Debian package (and any other packages built using make
    install). This bash completion is generated by the option parser, so it
    covers all commands, all options, and will never go out of date!
  * As well as tab completing "git-annex" commands, "git annex" will also tab
    complete. However, git's bash completion script needs a patch,
    which I've submitted, for this to work prefectly.
  * version --raw now works when run outside a git repository.
  * assistant --startdelay now works when run outside a git repository.
  * dead now accepts multiple --key options.
  * addurl now accepts --prefix and --suffix options to adjust the
    filenames used.
  * sync --content: Fix bug that caused files to be uploaded to eg,
    more archive remotes than wanted copies, only to later be dropped
    to satisfy the preferred content settings.
  * importfeed: Improve detection of known items whose url has changed,
    and avoid adding redundant files. Where before this only looked at
    permalinks in rss feeds, it now also looks at guids.
  * importfeed: Look at not only permalinks, but now also guids
    to identify previously downloaded files.
  * Webapp: Now features easy setup of git-annex repositories on gitlab.com.
  * Adjust debian build deps: The webapp can now build on arm64, s390x
    and hurd-i386. WebDAV support is also available on those architectures.
  * Debian package now maintained by Richard Hartmann.
  * Support building without persistent database on for systems that
    lack TH. This removes support for incremental fsck.

 -- Joey Hess <id@joeyh.name>  Mon, 27 Jul 2015 12:24:49 -0400
